from bot_api.abc.dto_abc import DtoABC
from bot_api.model.version_dto import VersionDTO


class SettingsDTO(DtoABC):
    def __init__(
        self,
        web_version: str,
        api_version: VersionDTO,
        config_path: str,
        web_base_url: str,
        api_base_url: str,
        token_expire_time: int,
        refresh_token_expire_time: int,
        mail_user: str,
        mail_port: int,
        mail_host: str,
        mail_transceiver: str,
        mail_transceiver_address: str,
    ):
        DtoABC.__init__(self)

        self._web_version = web_version
        self._api_version = api_version
        self._config_path = config_path
        self._web_base_url = web_base_url
        self._api_base_url = api_base_url

        self._token_expire_time = token_expire_time
        self._refresh_token_expire_time = refresh_token_expire_time

        self._mail_user = mail_user
        self._mail_port = mail_port
        self._mail_host = mail_host
        self._mail_transceiver = mail_transceiver
        self._mail_transceiver_address = mail_transceiver_address

    def from_dict(self, values: dict):
        self._web_version = values["webVersion"]
        self._api_version.from_dict(values["apiVersion"])
        self._config_path = values["configPath"]
        self._web_base_url = values["webBaseURL"]
        self._api_base_url = values["apiBaseURL"]
        self._token_expire_time = values["tokenExpireTime"]
        self._refresh_token_expire_time = values["refreshTokenExpireTime"]
        self._mail_user = values["mailUser"]
        self._mail_port = values["mailPort"]
        self._mail_host = values["mailHost"]
        self._mail_transceiver = values["mailTransceiver"]
        self._mail_transceiver_address = values["mailTransceiverAddress"]

    def to_dict(self) -> dict:
        return {
            "webVersion": self._web_version,
            "apiVersion": self._api_version.str,
            "configPath": self._config_path,
            "webBaseURL": self._web_base_url,
            "apiBaseURL": self._api_base_url,
            "tokenExpireTime": self._token_expire_time,
            "refreshTokenExpireTime": self._refresh_token_expire_time,
            "mailUser": self._mail_user,
            "mailPort": self._mail_port,
            "mailHost": self._mail_host,
            "mailTransceiver": self._mail_transceiver,
            "mailTransceiverAddress": self._mail_transceiver_address,
        }
