import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console
from cpl_query.extension import List

from modules.level.configuration.level_server_settings import LevelServerSettings


class LevelSettings(ConfigurationModelABC):
    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._servers: List[LevelServerSettings] = List()

    @property
    def servers(self) -> List[LevelServerSettings]:
        return self._servers

    def from_dict(self, settings: dict):
        try:
            servers = List(LevelServerSettings)
            for s in settings:
                st = LevelServerSettings()
                settings[s]["Id"] = s
                st.from_dict(settings[s])
                servers.append(st)
            self._servers = servers
        except Exception as e:
            Console.error(f"[ ERROR ] [ {__name__} ]: Reading error in {type(self).__name__} settings")
            Console.error(f"[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}")
