import {NgModule} from "@angular/core";
import {RouterModule, Routes} from "@angular/router";
import {ServerDashboardComponent} from "./server-dashboard/server-dashboard.component";
import {ProfileComponent} from "./profile/profile.component";
import {MembersComponent} from "./members/members.component";

const routes: Routes = [
  {path: '', component: ServerDashboardComponent},
  {path: 'members', component: MembersComponent},
  {path: 'members/:memberId', component: ProfileComponent},
  {path: 'auto-roles', loadChildren: () => import('./auto-role/auto-role.module').then(m => m.AutoRoleModule)},
  {path: 'levels', loadChildren: () => import('./levels/levels.module').then(m => m.LevelsModule)},
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class ServerRoutingModule {
}
